
// Loading Config-File
int cnc_load_config(void);

// Prepare the CNC-Machine for Start (x = Width, y = Height)
int cnc_start(int x, int y);

// Stop the CNC-Machine
int cnc_stop(void);

// Turn off the CNC-Machine
int cnc_off(void);

// Return CNC-Machine to Possition 0,0,0
int cnc_reset(void);

// Set the Speed of the X- and Y-Axis of the CNC-Machine
int cnc_set_speed_xy(int speed);

// Set the Softstart On/Off
int cnc_soft_start(int value);

// Set the Speed of the Z-Axis of the CNC-Machine
int cnc_set_speed_z(int speed);

// Change the Z-Axis and Tool of the CNC-Machine
int cnc_tool_change(int tool_nr);

// Go to X- und Y-Possition
int cnc_go_xy(int x, int y);

// Go to Z-Possition
int cnc_go_z(int pos_z);

// Go to Z-Possition
int cnc_check_z(void);

// Addition Drill and Pen commands
int drill_on(void);
int drill_off(void);
int drill_set_speed(int speed);
int drill(void);
int pen(int updown);



