
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>

#include "config.h"

int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;
int active_pen = 0;

FILE *cncout_plugin_stream = NULL;

int cncout_plugin_check_z(void) {
	return 0;
}

int cncout_plugin_check_size(void) {
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	return 0;
}

int cncout_plugin_reset(void) {
	fprintf(cncout_plugin_stream, "PU;\n");
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	if ((cncout_plugin_stream = fopen("/tmp/ecad_hpgl-output.plt", "w")) != 0) {
		down_pos = z;
		cnc_last_z = down_pos;
		fprintf(cncout_plugin_stream, "IN;\n");
		fprintf(cncout_plugin_stream, "IW0,0,%i,%i;\n", x * 4, y * 4);
		fprintf(cncout_plugin_stream, "PU;\n");
		fprintf(cncout_plugin_stream, "SP%i;\n", active_pen + 1);
	} else {
		cncout_plugin_stream = NULL;
	}
	return 0;
}

int cncout_plugin_stop(void) {
	fprintf(cncout_plugin_stream, "PU;\n");
	fprintf(cncout_plugin_stream, "\n");
	if (cncout_plugin_stream != NULL) {
		fclose(cncout_plugin_stream);
	}
	return 0;
}

int cncout_plugin_off(void) {
	fprintf(cncout_plugin_stream, "PU;\n");
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	active_pen = tool_nr + 1;
	fprintf(cncout_plugin_stream, "SP%i;\n", active_pen);
	return 0;
}

int cncout_plugin_soft_start(int value) {
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
	if (cnc_last_x != x || cnc_last_y != y) {
//		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "PA%ix%i;\n", (int)((float)x * 4), (int)((float)y * 4));
//		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "PA%ix%i;\n", (int)((float)x * 4), (int)((float)y * 4));
		}
	}
	cncout_plugin_go_z(z);
	cnc_last_x = x;
	cnc_last_y = y;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	if (cnc_last_x != x) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "PA%ix%i;\n", (int)((float)x * 4), (int)((float)cnc_last_y * 4));
		}
	}
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	if (cnc_last_y != y) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "PA%ix%i;\n", (int)((float)cnc_last_x * 4), (int)((float)y * 4));
		}
	}
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int pos_z) {
	if (pos_z < down_pos) {
		fprintf(cncout_plugin_stream, "PD;\n");
	} else {
		fprintf(cncout_plugin_stream, "PU;\n");
	}
	cnc_last_z = pos_z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	return 0;
}

int cncout_plugin_drill_off(void) {
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			fprintf(cncout_plugin_stream, "PU;\n");
			cnc_last_updown = updown;
		} else if (updown == 2) {
			fprintf(cncout_plugin_stream, "PD;\n");
			cnc_last_updown = 1;
		} else if (updown == 1) {
			fprintf(cncout_plugin_stream, "PD;\n");
			cnc_last_updown = updown;
		} else if (updown == 0) {
			fprintf(cncout_plugin_stream, "PU;\n");
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 0;
	active_pen = 0;
	return 0;
}
