
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>

#include "config.h"

int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;

FILE *cncout_plugin_stream = NULL;

int cncout_plugin_check_z(void) {
	return 0;
}

int cncout_plugin_check_size(void) {
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	return 0;
}

int cncout_plugin_soft_start(int value) {
	return 0;
}

int cncout_plugin_reset(void) {
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	if ((cncout_plugin_stream = fopen("/tmp/ecad_svg-output.svg", "w")) != 0) {
		down_pos = z;
		cnc_last_z = down_pos;
		fprintf(cncout_plugin_stream, "<?xml version=\"1.0\" standalone=\"no\"?>\n");
		fprintf(cncout_plugin_stream, "<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20010904//EN\" \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n");
		fprintf(cncout_plugin_stream, "<svg version=\"1.0\" xmlns=\"http://www.w3.org/2000/svg\" width=\"%ipt\" height=\"%ipt\" viewBox=\"0 0 %i %i\" preserveAspectRatio=\"xMidYMid meet\">\n", (int)((float)x / 10.0), (int)((float)y / 10.0), (int)((float)x / 10.0), (int)((float)y / 10.0));
		fprintf(cncout_plugin_stream, "	<metadata>\n");
		fprintf(cncout_plugin_stream, "		Created by mXm-CNC (SVG-Output)\n");
		fprintf(cncout_plugin_stream, "	</metadata>\n");
		fprintf(cncout_plugin_stream, "	<g id=\"Layer 0\">\n");
		fprintf(cncout_plugin_stream, "	<path d=\"\n");
	} else {
		cncout_plugin_stream = NULL;
	}
	return 0;
}

int cncout_plugin_stop(void) {
	fprintf(cncout_plugin_stream, "		\"\n");
	fprintf(cncout_plugin_stream, "		style=\"fill:none;fill-opacity:0.75000000;fill-rule:evenodd;stroke:#000000;stroke-width:1.0000000px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1.0000000\" />\n");
	fprintf(cncout_plugin_stream, "	</g>\n");
	fprintf(cncout_plugin_stream, "</svg>\n");
	fprintf(cncout_plugin_stream, "\n");
	if (cncout_plugin_stream != NULL) {
		fclose(cncout_plugin_stream);
	}
	return 0;
}

int cncout_plugin_off(void) {
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
	if (cnc_last_x != x || cnc_last_y != y) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "L %0.2f,%0.2f\n", (float)x / 10.0, (float)y / 10.0);
		} else {
			fprintf(cncout_plugin_stream, "M %0.2f,%0.2f\n", (float)x / 10.0, (float)y / 10.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "L %0.2f,%0.2f\n", (float)x / 10.0, (float)y / 10.0);
		} else {
			fprintf(cncout_plugin_stream, "M %0.2f,%0.2f\n", (float)x / 10.0, (float)y / 10.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int pos_z) {
	cnc_last_z = pos_z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	return 0;
}

int cncout_plugin_drill_off(void) {
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			cnc_last_updown = updown;
		} else if (updown == 2) {
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 0;
	return 0;
}
