/** \file cb_filedialog.c
 *  \brief GUI-Callbacks - Filedialog-Functions
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <gnome.h>
#include <glade/glade.h>

#include "app.h"
#include "cam_imgload.h"

//! Callback -- Filedialog / Close
void on_filedialog_response (GtkDialog *dialog, gint response, gpointer user_data) {
	gtk_widget_hide(app->filedialog);
//	if (response == GTK_RESPONSE_OK) {
//	}
}

//! Callback -- Filesavedialog / Close
void on_filesavedialog_response (GtkDialog *dialog, gint response, gpointer user_data) {
	gtk_widget_hide(app->filesavedialog);
//	if (response == GTK_RESPONSE_OK) {
//	}
}
