
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>

int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;

FILE *cncout_plugin_stream = NULL;

int cncout_plugin_check_z(void) {
	return 0;
}

int cncout_plugin_check_size(void) {
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	return 0;
}

int cncout_plugin_soft_start(int value) {
	return 0;
}

int cncout_plugin_reset(void) {
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	if ((cncout_plugin_stream = fopen("/tmp/ecad_dxf3d-output.dxf", "w")) != 0) {
		fprintf(cncout_plugin_stream, "  0\n");
		fprintf(cncout_plugin_stream, "SECTION\n");
		fprintf(cncout_plugin_stream, "  2\n");
		fprintf(cncout_plugin_stream, "ENTITIES\n");
	} else {
		cncout_plugin_stream = NULL;
	}
	return 0;
}

int cncout_plugin_stop(void) {
	fprintf(cncout_plugin_stream, " 0\n");
	fprintf(cncout_plugin_stream, "ENDSEC\n");
	fprintf(cncout_plugin_stream, "  0\n");
	fprintf(cncout_plugin_stream, "EOF\n");
	if (cncout_plugin_stream != NULL) {
		fclose(cncout_plugin_stream);
	}
	return 0;
}

int cncout_plugin_off(void) {
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
 	if (cnc_last_x != x || cnc_last_y != y) {
		// Line-Mode
		fprintf(cncout_plugin_stream, "  0\n");
		fprintf(cncout_plugin_stream, "LINE\n");
		// Layer 0
		fprintf(cncout_plugin_stream, "  8\n");
		fprintf(cncout_plugin_stream, "0\n");
		// X-Cord
		fprintf(cncout_plugin_stream, " 10\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_x / 100.0);
		// Y-Cord
		fprintf(cncout_plugin_stream, " 20\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_y / 100.0);
		// Z-Cord
		fprintf(cncout_plugin_stream, " 30\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_z / 100.0);
		// X-Cord
		fprintf(cncout_plugin_stream, " 11\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)x / 100.0);
		// Y-Cord
		fprintf(cncout_plugin_stream, " 21\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)y / 100.0);
		// Z-Cord
		fprintf(cncout_plugin_stream, " 31\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_z / 100.0);
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		// Line-Mode
		fprintf(cncout_plugin_stream, "  0\n");
		fprintf(cncout_plugin_stream, "LINE\n");
		// Layer 0
		fprintf(cncout_plugin_stream, "  8\n");
		fprintf(cncout_plugin_stream, "0\n");
		// X-Cord
		fprintf(cncout_plugin_stream, " 10\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_x / 100.0);
		// Y-Cord
		fprintf(cncout_plugin_stream, " 20\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_y / 100.0);
		// Z-Cord
		fprintf(cncout_plugin_stream, " 30\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_z / 100.0);
		// X-Cord
		fprintf(cncout_plugin_stream, " 11\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)x / 100.0);
		// Y-Cord
		fprintf(cncout_plugin_stream, " 21\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)y / 100.0);
		// Z-Cord
		fprintf(cncout_plugin_stream, " 31\n");
		fprintf(cncout_plugin_stream, "%0.2f\n", (float)z / 100.0);
	}
	cnc_last_y = y;
	cnc_last_x = x;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int z) {
	// Line-Mode
	fprintf(cncout_plugin_stream, "  0\n");
	fprintf(cncout_plugin_stream, "LINE\n");
	// Layer 0
	fprintf(cncout_plugin_stream, "  8\n");
	fprintf(cncout_plugin_stream, "0\n");
	// X-Cord
	fprintf(cncout_plugin_stream, " 10\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_x / 100.0);
	// Y-Cord
	fprintf(cncout_plugin_stream, " 20\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_y / 100.0);
	// Z-Cord
	fprintf(cncout_plugin_stream, " 30\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_z / 100.0);
	// X-Cord
	fprintf(cncout_plugin_stream, " 11\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_x / 100.0);
	// Y-Cord
	fprintf(cncout_plugin_stream, " 21\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)cnc_last_y / 100.0);
	// Z-Cord
	fprintf(cncout_plugin_stream, " 31\n");
	fprintf(cncout_plugin_stream, "%0.2f\n", (float)z / 100.0);

	cnc_last_z = z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	return 0;
}

int cncout_plugin_drill_off(void) {
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			cnc_last_updown = updown;
		} else if (updown == 2) {
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 0;
	return 0;
}
