
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>

#include "config.h"

int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;

FILE *cncout_plugin_stream = NULL;

int cncout_plugin_check_z(void) {
	return 0;
}

int cncout_plugin_check_size(void) {
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	return 0;
}

int cncout_plugin_soft_start(int value) {
	return 0;
}

int cncout_plugin_reset(void) {
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	if ((cncout_plugin_stream = fopen("/tmp/ecad_eps-output.eps", "w")) != 0) {
		down_pos = z;
		cnc_last_z = down_pos;
		fprintf(cncout_plugin_stream, "%%!PS-Adobe-3.0 EPSF-3.0\n");
		fprintf(cncout_plugin_stream, "%%%%Creator: Adobe Illustrator by mXm-CNC\n");
		fprintf(cncout_plugin_stream, "%%%%Title: mXm CNC-EPS-Output\n");
		fprintf(cncout_plugin_stream, "%%%%CreationDate: Thu Mar  9 23:11:12 2006\n");
		fprintf(cncout_plugin_stream, "%%%%BoundingBox: 0 0 %i %i\n", x, y);
		fprintf(cncout_plugin_stream, "%%%%DocumentData: Clean7Bit\n");
		fprintf(cncout_plugin_stream, "%%%%EndComments\n");
		fprintf(cncout_plugin_stream, "%%%%BeginProlog\n");
		fprintf(cncout_plugin_stream, "/b {false true def} def\n");
		fprintf(cncout_plugin_stream, "/e {false false def closepath false not fill} def\n");
		fprintf(cncout_plugin_stream, "/m {moveto} def\n");
		fprintf(cncout_plugin_stream, "/l {lineto} def\n");
		fprintf(cncout_plugin_stream, "%%%%EndProlog\n");
		fprintf(cncout_plugin_stream, "%%%%BeginSetup\n");
		fprintf(cncout_plugin_stream, "%%%%EndSetup\n");
		fprintf(cncout_plugin_stream, "0.000 0.000 0.000 1.000 setcmykcolor\n");
		fprintf(cncout_plugin_stream, "b\n");
	} else {
		cncout_plugin_stream = NULL;
	}
	return 0;
}

int cncout_plugin_stop(void) {
	fprintf(cncout_plugin_stream, "e\n");
	fprintf(cncout_plugin_stream, "%%%%Trailer\n");
	fprintf(cncout_plugin_stream, "%%%%EOF\n");
	if (cncout_plugin_stream != NULL) {
		fclose(cncout_plugin_stream);
	}
	return 0;
}

int cncout_plugin_off(void) {
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
	if (cnc_last_x != x || cnc_last_y != y) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "%0.2f %0.2f l\n", (float)x / 5.0, (float)y / 5.0);
		} else {
			fprintf(cncout_plugin_stream, "%0.2f %0.2f m\n", (float)x / 5.0, (float)y / 5.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		if (cnc_last_z < down_pos) {
			fprintf(cncout_plugin_stream, "%0.2f %0.2f l\n", (float)x / 5.0, (float)y / 5.0);
		} else {
			fprintf(cncout_plugin_stream, "%0.2f %0.2f m\n", (float)x / 5.0, (float)y / 5.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int pos_z) {
	cnc_last_z = pos_z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	return 0;
}

int cncout_plugin_drill_off(void) {
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			cnc_last_updown = updown;
		} else if (updown == 2) {
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 0;
	return 0;
}
